Module javafx.graphics
Package javafx.scene.layout

## Class HBox

- java.lang.Object
- - javafx.scene.Node
  - - javafx.scene.Parent
    - - javafx.scene.layout.Region
      - - javafx.scene.layout.Pane
        - - javafx.scene.layout.HBox

- All Implemented Interfaces:
    `Styleable`, `EventTarget`

      public class HBox
      extends Pane

  HBox lays out its children in a single horizontal row. If the hbox has a border and/or padding set, then the contents will be laid out within those insets.

  HBox example:

           HBox hbox = new HBox(8); // spacing = 8
           hbox.getChildren().addAll(new Label("Name:), new TextBox());

  HBox will resize children (if resizable) to their preferred widths and uses its fillHeight property to determine whether to resize their heights to fill its own height or keep their heights to their preferred (fillHeight defaults to true). The alignment of the content is controlled by the alignment property, which defaults to Pos.TOP_LEFT.

  If an hbox is resized larger than its preferred width, by default it will keep children to their preferred widths, leaving the extra space unused. If an application wishes to have one or more children be allocated that extra space it may optionally set an hgrow constraint on the child. See "Optional Layout Constraints" for details.

  HBox lays out each managed child regardless of the child's visible property value; unmanaged children are ignored.

  ### Resizable Range

  An hbox's parent will resize the hbox within the hbox's resizable range during layout. By default the hbox computes this range based on its content as outlined in the table below.

  HBox Resize Table
  | width | height
  minimum | left/right insets plus the sum of each child's min width plus spacing between each child. | top/bottom insets plus the largest of the children's min heights.
  preferred | left/right insets plus the sum of each child's pref width plus spacing between each child. | top/bottom insets plus the largest of the children's pref heights.
  maximum | Double.MAX_VALUE | Double.MAX_VALUE

  An hbox's unbounded maximum width and height are an indication to the parent that it may be resized beyond its preferred size to fill whatever space is assigned to it.

  HBox provides properties for setting the size range directly. These properties default to the sentinel value USE_COMPUTED_SIZE, however the application may set them to other values as needed:

           hbox.setPrefWidth(400);

  Applications may restore the computed values by setting these properties back to USE_COMPUTED_SIZE.

  HBox does not clip its content by default, so it is possible that children's bounds may extend outside its own bounds if a child's min size prevents it from being fit within the hbox.

  ### Optional Layout Constraints

  An application may set constraints on individual children to customize HBox's layout. For each constraint, HBox provides a static method for setting it on the child.

  HBox Constraint Table
  Constraint | Type | Description
  --- | --- | ---
  hgrow | javafx.scene.layout.Priority | The horizontal grow priority for the child.
  margin | javafx.geometry.Insets | Margin space around the outside of the child.

  For example, if an hbox needs the TextField to be allocated all extra space:

           HBox hbox = new HBox();
           TextField field = new TextField();
           HBox.setHgrow(field, Priority.ALWAYS);
           hbox.getChildren().addAll(new Label("Search:"), field, new Button("Go"));

  If more than one child has the same grow priority set, then the hbox will allocate equal amounts of space to each. HBox will only grow a child up to its maximum width, so if the child has a max width other than Double.MAX_VALUE, the application may need to override the max to allow it to grow. For example:

           HBox hbox = new HBox();
           Button button1 = new Button("Add");
           Button button2 = new Button("Remove");
           HBox.setHgrow(button1, Priority.ALWAYS);
           HBox.setHgrow(button2, Priority.ALWAYS);
           button1.setMaxWidth(Double.MAX_VALUE);
           button2.setMaxWidth(Double.MAX_VALUE);
           hbox.getChildren().addAll(button1, button2);

  Since:
    JavaFX 2.0

- - ### Property Summary

    Properties
    Type | Property | Description
    --- | --- | ---
    `ObjectProperty<Pos>` | `alignment` | The overall alignment of children within the hbox's width and height.
    `BooleanProperty` | `fillHeight` | Whether or not resizable children will be resized to fill the full height of the hbox or be resized to their preferred height and aligned according to the `alignment` vpos value.
    `DoubleProperty` | `spacing` | The amount of horizontal space between each child in the hbox.

    - ### Properties inherited from class javafx.scene.layout.Region

      `background, border, cacheShape, centerShape, height, insets, maxHeight, maxWidth, minHeight, minWidth, opaqueInsets, padding, prefHeight, prefWidth, scaleShape, shape, snapToPixel, width`

    - ### Properties inherited from class javafx.scene.Parent

      `needsLayout`

    - ### Properties inherited from class javafx.scene.Node

      `accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

  - ### Field Summary

    - ### Fields inherited from class javafx.scene.layout.Region

      `USE_COMPUTED_SIZE, USE_PREF_SIZE`

    - ### Fields inherited from class javafx.scene.Node

      `BASELINE_OFFSET_SAME_AS_HEIGHT`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `HBox()` | Creates an HBox layout with spacing = 0.
    `HBox​(double spacing)` | Creates an HBox layout with the specified spacing between children.
    `HBox​(double spacing, Node... children)` | Creates an HBox layout with the specified spacing between children.
    `HBox​(Node... children)` | Creates an HBox layout with spacing = 0.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ObjectProperty<Pos>` | `alignmentProperty()` | The overall alignment of children within the hbox's width and height.
    `static void` | `clearConstraints​(Node child)` | Removes all hbox constraints from the child node.
    `protected double` | `computeMinHeight​(double width)` | Computes the minimum height of this region.
    `protected double` | `computeMinWidth​(double height)` | Computes the minimum width of this region.
    `protected double` | `computePrefHeight​(double width)` | Computes the preferred height of this region for the given width; Region subclasses should override this method to return an appropriate value based on their content and layout strategy.
    `protected double` | `computePrefWidth​(double height)` | Computes the preferred width of this region for the given height.
    `BooleanProperty` | `fillHeightProperty()` | Whether or not resizable children will be resized to fill the full height of the hbox or be resized to their preferred height and aligned according to the `alignment` vpos value.
    `Pos` | `getAlignment()` | Gets the value of the property alignment.
    `double` | `getBaselineOffset()` | Calculates the baseline offset based on the first managed child.
    `static List<CssMetaData<? extends Styleable,​?>>` | `getClassCssMetaData()` |
    `Orientation` | `getContentBias()` | Returns the orientation of a node's resizing bias for layout purposes.
    `List<CssMetaData<? extends Styleable,​?>>` | `getCssMetaData()` | This method should delegate to `Node.getClassCssMetaData()` so that a Node's CssMetaData can be accessed without the need for reflection.
    `static Priority` | `getHgrow​(Node child)` | Returns the child's hgrow constraint if set.
    `static Insets` | `getMargin​(Node child)` | Returns the child's margin constraint if set.
    `double` | `getSpacing()` | Gets the value of the property spacing.
    `boolean` | `isFillHeight()` | Gets the value of the property fillHeight.
    `protected void` | `layoutChildren()` | Invoked during the layout pass to layout the children in this `Parent`.
    `void` | `requestLayout()` | Requests a layout pass to be performed before the next scene is rendered.
    `void` | `setAlignment​(Pos value)` | Sets the value of the property alignment.
    `void` | `setFillHeight​(boolean value)` | Sets the value of the property fillHeight.
    `static void` | `setHgrow​(Node child, Priority value)` | Sets the horizontal grow priority for the child when contained by an hbox.
    `static void` | `setMargin​(Node child, Insets value)` | Sets the margin for the child when contained by an hbox.
    `void` | `setSpacing​(double value)` | Sets the value of the property spacing.
    `DoubleProperty` | `spacingProperty()` | The amount of horizontal space between each child in the hbox.

    - ### Methods inherited from class javafx.scene.layout.Pane

      `getChildren`

    - ### Methods inherited from class javafx.scene.layout.Region

      `backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, computeMaxHeight, computeMaxWidth, getBackground, getBorder, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isResizable, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

    - ### Methods inherited from class javafx.scene.Parent

      `getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, lookup, needsLayoutProperty, queryAccessibleAttribute, requestParentLayout, setNeedsLayout, updateBounds`

    - ### Methods inherited from class javafx.scene.Node

      `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInitialFocusTraversable, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, relocate, removeEventFilter, removeEventHandler, requestFocus, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, toString, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javafx.css.Styleable

      `getStyleableNode`

- - ### Property Detail

    - #### spacing

          public final DoubleProperty spacingProperty

      The amount of horizontal space between each child in the hbox.
      See Also:
        `getSpacing()`, `setSpacing(double)`

    - #### alignment

          public final ObjectProperty<Pos> alignmentProperty

      The overall alignment of children within the hbox's width and height.
      See Also:
        `getAlignment()`, `setAlignment(Pos)`

    - #### fillHeight

          public final BooleanProperty fillHeightProperty

      Whether or not resizable children will be resized to fill the full height of the hbox or be resized to their preferred height and aligned according to the `alignment` vpos value. Note that if the hbox vertical alignment is set to BASELINE, then this property will be ignored and children will be resized to their preferred heights.
      See Also:
        `isFillHeight()`, `setFillHeight(boolean)`

  - ### Constructor Detail

    - #### HBox

          public HBox()

      Creates an HBox layout with spacing = 0.

    - #### HBox

          public HBox​(double spacing)

      Creates an HBox layout with the specified spacing between children.
      Parameters:
        `spacing` - the amount of horizontal space between each child

    - #### HBox

          public HBox​(Node... children)

      Creates an HBox layout with spacing = 0.
      Parameters:
        `children` - The initial set of children for this pane.
      Since:
        JavaFX 8.0

    - #### HBox

          public HBox​(double spacing,
                      Node... children)

      Creates an HBox layout with the specified spacing between children.
      Parameters:
        `spacing` - the amount of horizontal space between each child
        `children` - The initial set of children for this pane.
      Since:
        JavaFX 8.0

  - ### Method Detail

    - #### setHgrow

          public static void setHgrow​(Node child,
                                      Priority value)

      Sets the horizontal grow priority for the child when contained by an hbox. If set, the hbox will use the priority to allocate additional space if the hbox is resized larger than it's preferred width. If multiple hbox children have the same horizontal grow priority, then the extra space will be split evenly between them. If no horizontal grow priority is set on a child, the hbox will never allocate it additional horizontal space if available. Setting the value to null will remove the constraint.
      Parameters:
        `child` - the child of an hbox
        `value` - the horizontal grow priority for the child

    - #### getHgrow

          public static Priority getHgrow​(Node child)

      Returns the child's hgrow constraint if set.
      Parameters:
        `child` - the child node of an hbox
      Returns:
        the horizontal grow priority for the child or null if no priority was set

    - #### setMargin

          public static void setMargin​(Node child,
                                       Insets value)

      Sets the margin for the child when contained by an hbox. If set, the hbox will layout the child with the margin space around it. Setting the value to null will remove the constraint.
      Parameters:
        `child` - the child mode of the hbox
        `value` - the margin of space around the child

    - #### getMargin

          public static Insets getMargin​(Node child)

      Returns the child's margin constraint if set.
      Parameters:
        `child` - the child node of an hbox
      Returns:
        the margin for the child or null if no margin was set

    - #### clearConstraints

          public static void clearConstraints​(Node child)

      Removes all hbox constraints from the child node.
      Parameters:
        `child` - the child node

    - #### spacingProperty

          public final DoubleProperty spacingProperty()

      The amount of horizontal space between each child in the hbox.
      See Also:
        `getSpacing()`, `setSpacing(double)`

    - #### setSpacing

          public final void setSpacing​(double value)

      Sets the value of the property spacing.
      Property description:
        The amount of horizontal space between each child in the hbox.

    - #### getSpacing

          public final double getSpacing()

      Gets the value of the property spacing.
      Property description:
        The amount of horizontal space between each child in the hbox.

    - #### alignmentProperty

          public final ObjectProperty<Pos> alignmentProperty()

      The overall alignment of children within the hbox's width and height.
      See Also:
        `getAlignment()`, `setAlignment(Pos)`

    - #### setAlignment

          public final void setAlignment​(Pos value)

      Sets the value of the property alignment.
      Property description:
        The overall alignment of children within the hbox's width and height.

    - #### getAlignment

          public final Pos getAlignment()

      Gets the value of the property alignment.
      Property description:
        The overall alignment of children within the hbox's width and height.

    - #### fillHeightProperty

          public final BooleanProperty fillHeightProperty()

      Whether or not resizable children will be resized to fill the full height of the hbox or be resized to their preferred height and aligned according to the `alignment` vpos value. Note that if the hbox vertical alignment is set to BASELINE, then this property will be ignored and children will be resized to their preferred heights.
      See Also:
        `isFillHeight()`, `setFillHeight(boolean)`

    - #### setFillHeight

          public final void setFillHeight​(boolean value)

      Sets the value of the property fillHeight.
      Property description:
        Whether or not resizable children will be resized to fill the full height of the hbox or be resized to their preferred height and aligned according to the `alignment` vpos value. Note that if the hbox vertical alignment is set to BASELINE, then this property will be ignored and children will be resized to their preferred heights.

    - #### isFillHeight

          public final boolean isFillHeight()

      Gets the value of the property fillHeight.
      Property description:
        Whether or not resizable children will be resized to fill the full height of the hbox or be resized to their preferred height and aligned according to the `alignment` vpos value. Note that if the hbox vertical alignment is set to BASELINE, then this property will be ignored and children will be resized to their preferred heights.

    - #### getContentBias

          public Orientation getContentBias()

      Description copied from class: `Node`
      Returns the orientation of a node's resizing bias for layout purposes. If the node type has no bias, returns null. If the node is resizable and it's height depends on its width, returns HORIZONTAL, else if its width depends on its height, returns VERTICAL.

      Resizable subclasses should override this method to return an appropriate value.

      Overrides:
        `getContentBias` in class `Node`
      Returns:
        null unless one of its children has a content bias.
      See Also:
        `Node.isResizable()`, `Node.minWidth(double)`, `Node.minHeight(double)`, `Node.prefWidth(double)`, `Node.prefHeight(double)`, `Node.maxWidth(double)`, `Node.maxHeight(double)`

    - #### computeMinWidth

          protected double computeMinWidth​(double height)

      Description copied from class: `Region`
      Computes the minimum width of this region. Returns the sum of the left and right insets by default. region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a VERTICAL content bias, then the height parameter can be ignored.
      Overrides:
        `computeMinWidth` in class `Region`
      Parameters:
        `height` - the height that should be used if min width depends on it
      Returns:
        the computed minimum width of this region

    - #### computeMinHeight

          protected double computeMinHeight​(double width)

      Description copied from class: `Region`
      Computes the minimum height of this region. Returns the sum of the top and bottom insets by default. Region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a HORIZONTAL content bias, then the width parameter can be ignored.
      Overrides:
        `computeMinHeight` in class `Region`
      Parameters:
        `width` - the width that should be used if min height depends on it
      Returns:
        the computed minimum height for this region

    - #### computePrefWidth

          protected double computePrefWidth​(double height)

      Description copied from class: `Region`
      Computes the preferred width of this region for the given height. Region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a VERTICAL content bias, then the height parameter can be ignored.
      Overrides:
        `computePrefWidth` in class `Region`
      Parameters:
        `height` - the height that should be used if preferred width depends on it
      Returns:
        the computed preferred width for this region

    - #### computePrefHeight

          protected double computePrefHeight​(double width)

      Description copied from class: `Region`
      Computes the preferred height of this region for the given width; Region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a HORIZONTAL content bias, then the width parameter can be ignored.
      Overrides:
        `computePrefHeight` in class `Region`
      Parameters:
        `width` - the width that should be used if preferred height depends on it
      Returns:
        the computed preferred height for this region

    - #### requestLayout

          public void requestLayout()

      Description copied from class: `Parent`
      Requests a layout pass to be performed before the next scene is rendered. This is batched up asynchronously to happen once per "pulse", or frame of animation.

      If this parent is either a layout root or unmanaged, then it will be added directly to the scene's dirty layout list, otherwise requestParentLayout will be invoked.

      Overrides:
        `requestLayout` in class `Parent`

    - #### getBaselineOffset

          public double getBaselineOffset()

      Description copied from class: `Parent`
      Calculates the baseline offset based on the first managed child. If there is no such child, returns `Node.getBaselineOffset()`.
      Overrides:
        `getBaselineOffset` in class `Parent`
      Returns:
        baseline offset

    - #### layoutChildren

          protected void layoutChildren()

      Description copied from class: `Parent`
      Invoked during the layout pass to layout the children in this `Parent`. By default it will only set the size of managed, resizable content to their preferred sizes and does not do any node positioning.

      Subclasses should override this function to layout content as needed.

      Overrides:
        `layoutChildren` in class `Parent`

    - #### getClassCssMetaData

          public static List<CssMetaData<? extends Styleable,​?>> getClassCssMetaData()

      Returns:
        The CssMetaData associated with this class, which may include the CssMetaData of its superclasses.
      Since:
        JavaFX 8.0

    - #### getCssMetaData

          public List<CssMetaData<? extends Styleable,​?>> getCssMetaData()

      This method should delegate to `Node.getClassCssMetaData()` so that a Node's CssMetaData can be accessed without the need for reflection.
      Specified by:
        `getCssMetaData` in interface `Styleable`
      Overrides:
        `getCssMetaData` in class `Region`
      Returns:
        The CssMetaData associated with this node, which may include the CssMetaData of its superclasses.
      Since:
        JavaFX 8.0